## lomiri 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(lomiri VERSION 0.3.0 LANGUAGES C CXX)

option (ENABLE_UBUNTU_ACCOUNTSSERVICE "Build with Ubuntu's fork of accountsservice" OFF)

if (ENABLE_UBUNTU_ACCOUNTSSERVICE)
    add_compile_definitions (ENABLE_UBUNTU_ACCOUNTSSERVICE)
endif ()

set(SHELL_APP lomiri)
set(INDICATORS_CLIENT_APP indicators-client)
set(GREETER_APP lomiri-greeter)

set (DESKTOP_FILE_SHELL "${SHELL_APP}.desktop")
set (DESKTOP_FILE_GREETER "${GREETER_APP}.desktop")
set (DESKTOP_FILE_INDICATORSCLIENT "${INDICATORS_CLIENT_APP}.desktop")
set(QML_DEBUG OFF CACHE BOOL "Enable Qml Debugging")

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Instruct CMake to run moc and rcc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

# enable QML debugging
if(QML_DEBUG)
    add_definitions(-DQT_QML_DEBUG)
endif()

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
  ENABLE_COVERAGE_REPORT(TARGETS ${SHELL_APP} FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

find_package (ECM 1.7.0 QUIET NO_MODULE)
if (ECM_FOUND)
    # Provides us with -DECM_ENABLE_SANITIZERS='X'
    # Where X can be address, thread, memory, leak, undefined
    include("${ECM_MODULE_DIR}/ECMEnableSanitizers.cmake")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0.0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override" )
  endif()
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)

include(FindPkgConfig)
find_package(Qt5Core 5.6 REQUIRED)
find_package(Qt5Qml 5.6 REQUIRED)
find_package(Qt5Quick 5.6 REQUIRED)
find_package(Qt5Gui 5.6 REQUIRED)
find_package(Qt5DBus 5.6 REQUIRED)
find_package(Qt5Concurrent 5.6 REQUIRED)
find_package(Qt5Sql 5.6 REQUIRED)
find_package(Qt5Test 5.6 REQUIRED)
find_package(Qt5Svg 5.6 REQUIRED)
find_package(Qt5Network 5.6 REQUIRED)
find_package(Qt5Xml 5.6 REQUIRED)
find_package(Intl REQUIRED)

pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=28)
pkg_check_modules(GEONAMES REQUIRED geonames>=0.2)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.32)
pkg_check_modules(LAUNCHER_API REQUIRED lomiri-shell-launcher=13)
pkg_check_modules(QMENUMODEL REQUIRED qmenumodel)
pkg_check_modules(GD3 REQUIRED gnome-desktop-3.0)
# 0.1.5 adds lal-application-end.target.
pkg_check_modules(UAL REQUIRED lomiri-app-launch-0>=0.1.5)
pkg_check_modules(LOMIRIGESTURES REQUIRED LomiriGestures)
pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
pkg_check_modules(LOMIRISCHEMA REQUIRED lomiri-schemas>=0.1.4)

option(WITH_MIR2 "Build against Mir 2" OFF)

if (WITH_MIR2)
    pkg_check_modules(QTMIRSERVER REQUIRED qt5mir2server>=0.6.0)
    pkg_check_modules(MIRAL REQUIRED miral>=3.0)
    pkg_check_modules(MIROIL REQUIRED miroil)

    add_definitions(-DWITH_MIR2=1)
else()
    pkg_check_modules(QTMIRSERVER REQUIRED qt5mir1server>=0.6.0)
    pkg_search_module(MIRAL REQUIRED mir1al miral<3.0)
endif()

### Check LomiriGestures private headers. No pkg-config (.pc) file is provided for them
find_path(LOMIRIGESTUREPRIV
    NAMES LomiriGestures/private/damper_p.h LomiriGestures/private/ucswipearea_p.h LomiriGestures/private/ucswipearea_p_p.h
    PATHS ${LOMIRIGESTURES_INCLUDEDIR}/LomiriGestures/${LOMIRIGESTURES_VERSION}
    NO_DEFAULT_PATH)
if (${LOMIRIGESTUREPRIV} STREQUAL LOMIRIGESTUREPRIV-NOTFOUND)
   message(FATAL_ERROR "LomiriGestures private headers not found.")
endif()
# end of LomiriGesture private headers check

# Standard install paths
include(GNUInstallDirs)

set(SHELL_APP_FULL_DIR ${CMAKE_INSTALL_FULL_DATADIR}/lomiri)
add_definitions(-DSHELL_APP_FULL_DIR=\"${SHELL_APP_FULL_DIR}\")
set(SHELL_PRIVATE_FULL_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR}/lomiri)
set(SHELL_PRIVATE_FULL_LIBEXECDIR ${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri)

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugin_private_module_dir LomiriSystemSettings OUTPUT_VARIABLE USS_PRIVATE_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(USS_PRIVATE_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine USS private plugin installation dir.")
endif()

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix lomiri-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_INSTALL_QML STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin installation dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir lomiri-shell-api OUTPUT_VARIABLE SHELL_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin import dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive -pedantic -Wall -Wextra")

set (CMAKE_CXX_STANDARD 17)

if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

# gtk and lomiri-core (actually sigc++) do not like Qt defining macros named
# "signals" and "slots"
add_definitions(-DQT_NO_KEYWORDS)

# Save a few container detach and conversions
add_definitions(-DQT_STRICT_ITERATORS)

# Use the fast string builder
add_definitions(-DQT_USE_QSTRINGBUILDER)

# Autopilot tests
include(autopilot)
declare_autopilot_test(shell lomiri.shell ${CMAKE_SOURCE_DIR}/tests/autopilot/)

set(MOCK_INDICATOR_SERVICE_APP lomiri-mock-indicator-service)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    ${APPLICATION_API_INCLUDE_DIRS}
)

# Quiet logger
set(QUIET_LOGGER OFF CACHE BOOL "Disable test output on stdout.")
if(NOT QUIET_LOGGER)
    set(STDOUT_LOGGER "-o" "-,txt")
endif()

execute_process(COMMAND dpkg-architecture -qDEB_HOST_ARCH OUTPUT_VARIABLE ARCH)
if (NOT ARCH MATCHES "arm*")
    set(ENABLE_TOUCH_EMULATION true)
    add_definitions(-DLOMIRI_ENABLE_TOUCH_EMULATION)
    pkg_check_modules(MOUSETOUCHADAPTOR_LIBS REQUIRED x11 xcb xi)
else()
    set(ENABLE_TOUCH_EMULATION false)
    message(STATUS "Touch emulation support disabled.")
endif()

# add subdirectories to build
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(qml)

# Tests
set(NO_TESTS OFF CACHE BOOL "Disable tests.")
if (NOT NO_TESTS)
    pkg_check_modules(QTDBUSTEST REQUIRED
        libqtdbustest-1
        libqtdbusmock-1
        )
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
else()
    message(STATUS "Tests disabled")
endif()

set(DISPLAYED_DISTRO_NAME "" CACHE STRING
    "The distro name displayed in first-run wizard and other places. If not set, will read /etc/os-release")
add_subdirectory(plugins)

#
# Data files
#
add_subdirectory(data)

#
# Translation
#
add_subdirectory(po)

#
# Documentation
#
add_subdirectory(doc)

=== tools/CMakeLists.txt ===
add_subdirectory(indicatorsclient)
add_subdirectory(menutool)

install(FILES unlock-device DESTINATION ${SHELL_APP_FULL_DIR})

=== data/systemd-user/CMakeLists.txt ===
pkg_check_modules(SYSTEMD systemd)

if (${SYSTEMD_FOUND})
    find_program(DUAE_BIN dbus-update-activation-environment REQUIRED)
    find_program(XWAYLAND_BIN Xwayland REQUIRED)

    if (${SYSTEMD_VERSION} VERSION_LESS 247)
        pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
    else()
        pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemd_user_unit_dir)
    endif()

    # lomiri-<MODE>.service

    set(MODES full-greeter full-shell greeter shell)

    foreach(MODE ${MODES})
        set(CONFLICT_UNITS "")
        foreach(OTHER_MODE ${MODES})
            if(NOT ${OTHER_MODE} STREQUAL ${MODE})
                set(CONFLICT_UNITS "${CONFLICT_UNITS} lomiri-${OTHER_MODE}.service")
            endif()
        endforeach()
        string(STRIP "${CONFLICT_UNITS}" CONFLICT_UNITS)

        configure_file(
            lomiri-MODE.service.in
            ${CMAKE_CURRENT_BINARY_DIR}/lomiri-${MODE}.service
            @ONLY
        )

        install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/lomiri-${MODE}.service
            DESTINATION ${SYSTEMD_USER_UNIT_DIR}
        )
    endforeach()

    # lomiri-indicators.target

    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/lomiri-indicators.target" DESTINATION "${SYSTEMD_USER_UNIT_DIR}")

endif()

# lomiri-systemd-wrapper

configure_file(lomiri-systemd-wrapper.in ${CMAKE_CURRENT_BINARY_DIR}/lomiri-systemd-wrapper @ONLY)
install(PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/lomiri-systemd-wrapper
    DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}
)

# Xwayland startup script

configure_file(Xwayland.lomiri.in ${CMAKE_CURRENT_BINARY_DIR}/Xwayland.lomiri @ONLY)
install(PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/Xwayland.lomiri
    DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}
)

=== plugins/AccountsService/CMakeLists.txt ===
add_definitions(-DSM_BUSNAME=systemBus)
include_directories(${GLIB_INCLUDE_DIRS})

add_library(AccountsService-qml MODULE
    AccountsService.cpp
    AccountsServiceDBusAdaptor.cpp
    plugin.cpp
    )

target_link_libraries(AccountsService-qml
    Qt5::DBus Qt5::Qml
    ${GLIB_LIBRARIES}
    )

add_lomiri_plugin(AccountsService 0.1 AccountsService TARGETS AccountsService-qml)

set(DBUS_IFACE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/interfaces")
set(ACCOUNTS_IFACE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/accountsservice/interfaces")

install(FILES com.lomiri.shell.AccountsService.xml
        DESTINATION "${DBUS_IFACE_DIR}"
    )

# Create accountsservice symlink for above dbus interface
install(CODE "
execute_process(COMMAND mkdir -p \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
execute_process(COMMAND ln -sf ../../dbus-1/interfaces/com.lomiri.shell.AccountsService.xml \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
    ")

=== plugins/Cursor/CMakeLists.txt ===
add_subdirectory(3rd_party)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/3rd_party/xcursor
)

include_directories(
    SYSTEM
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
)

set(QMLPLUGIN_SRC
    plugin.cpp
    CursorImageInfo.cpp
    CursorImageProvider.cpp
    MousePointer.cpp
    InputDispatcherFilter.cpp
    # We need to run moc on this header
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirMousePointerInterface.h
    )

add_library(Cursor-qml SHARED
    ${QMLPLUGIN_SRC}
    )

target_link_libraries(Cursor-qml
    xcursorloader-static
    ${QT5PLATFORM_SUPPORT_LDFLAGS}
    Qt5::Qml Qt5::Quick Qt5::Svg
)

add_lomiri_plugin(Cursor 1.1 Cursor TARGETS Cursor-qml)

=== plugins/SessionBroadcast/CMakeLists.txt ===
include_directories(${GLIB_INCLUDE_DIRS})
add_definitions(-DSM_BUSNAME=systemBus)

add_library(SessionBroadcast-qml MODULE
    SessionBroadcast.cpp
    plugin.cpp
    )

target_link_libraries(SessionBroadcast-qml
    Qt5::DBus Qt5::Qml
    ${GLIB_LIBRARIES}
    )

add_lomiri_plugin(SessionBroadcast 0.1 SessionBroadcast TARGETS SessionBroadcast-qml)

=== plugins/WindowManager/CMakeLists.txt ===
include_directories(
    SYSTEM
    ${QTMIRSERVER_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}
)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${liblomiri-private_SOURCE_DIR}
)

set(WINDOWMANAGER_SRC
    AvailableDesktopArea.cpp
    TopLevelWindowModel.cpp
    Window.cpp
    WindowManagerPlugin.cpp
    WindowMargins.cpp
    Screen.cpp
    ScreenAttached.cpp
    Screens.cpp
    ScreensConfiguration.cpp
    ScreenWindow.cpp
    WindowManagerObjects.cpp
    Workspace.cpp
    WorkspaceManager.cpp
    WorkspaceModel.cpp
    InputMethodManager.cpp
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationInfoInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationManagerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceListInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/SurfaceManagerInterface.h
)

add_definitions(-DWINDOWMANAGERQML_LIBRARY)

add_library(windowmanager-qml SHARED ${WINDOWMANAGER_SRC})

target_link_libraries(windowmanager-qml
    Qt5::Qml Qt5::Quick Qt5::Gui
    ${QTMIRSERVER_LDFLAGS}
    lomiri-private
)

add_lomiri_plugin(WindowManager 1.0 WindowManager TARGETS windowmanager-qml)

=== src/liblomiri-private/CMakeLists.txt ===
set(LIB_NAME "lomiri-private")
set(SOVERSION 0)
set(VERSION ${SOVERSION}.0.0)

project(lib${LIB_NAME})

set(lib${LIB_NAME}_SRCS
    abstractdbusservicemonitor.cpp
    lomiridbusobject.cpp
    lomiridbusvirtualobject.cpp
    wmpolicyinterface.cpp
    )

add_library(${LIB_NAME} SHARED
    ${lib${LIB_NAME}_SRCS}
    )

set_target_properties(${LIB_NAME} PROPERTIES
    VERSION ${VERSION}
    SOVERSION ${SOVERSION}
    )

target_link_libraries(${LIB_NAME} Qt5::DBus)

# install library
install(TARGETS ${LIB_NAME}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )

=== tests/mocks/CMakeLists.txt ===
find_package(QmlPlugins)

# Set up and optionally install a mock plugin for lomiri.
#
# add_lomiri_mock(plugin version path
#     [PREFIX string]  # Install the plugin to the specified prefix under lomiri private plugin directory
#     [...]            # See export_qmlfiles and export_qmlplugin documentation for more options
# )

macro(add_lomiri_mock PLUGIN VERSION PATH)
    set(single PREFIX)
    cmake_parse_arguments(MOCK "" "${single}" "" ${ARGN})

    if (NOT MOCK_PREFIX)
        set(MOCK_PREFIX mocks)
    endif()

    export_qmlfiles(${PLUGIN} ${PATH}
        DESTINATION ${SHELL_INSTALL_QML}/${MOCK_PREFIX}
        TARGET_PREFIX ${MOCK_PREFIX}-Mock
        ${MOCK_UNPARSED_ARGUMENTS}
    )
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH}
        DESTINATION ${SHELL_INSTALL_QML}/${MOCK_PREFIX}
        TARGET_PREFIX ${MOCK_PREFIX}-Mock
        ${MOCK_UNPARSED_ARGUMENTS}
    )
endmacro()

add_subdirectory(AccountsService)
add_subdirectory(Biometryd)
add_subdirectory(Cursor)
add_subdirectory(GSettings.1.0)
add_subdirectory(indicator-service)
add_subdirectory(liblightdm)
add_subdirectory(libusermetrics)
add_subdirectory(LightDMController)
add_subdirectory(Hfd)
add_subdirectory(Powerd)
add_subdirectory(QMenuModel.1)
add_subdirectory(QOfono)
add_subdirectory(SessionBroadcast)
add_subdirectory(Lomiri)
add_subdirectory(QtMir/Application)
add_subdirectory(QtMultimedia)
add_subdirectory(WindowManager)
add_subdirectory(Wizard)
add_subdirectory(Utils)
add_subdirectory(UInput)

install(
  DIRECTORY data
  DESTINATION ${SHELL_APP_FULL_DIR}/mocks
)

=== tests/whitespace/CMakeLists.txt ===
#
# Test that all source files, cmakefiles, etc. do not contain trailing whitespace.
#

add_test(Whitespace ${CMAKE_CURRENT_SOURCE_DIR}/check_whitespace.py ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

=== plugins/Cursor/3rd_party/CMakeLists.txt ===
add_subdirectory(xcursor)

=== plugins/LightDM/FullLightDM/CMakeLists.txt ===
pkg_check_modules(LIBLIGHTDM REQUIRED liblightdm-qt5-3)

set(PLUGIN_CLASSNAME "FullLightDM")

add_definitions(-DFULL_LIGHTDM)

include_directories(
    ../
    ${CMAKE_CURRENT_BINARY_DIR}
    )

include_directories(
    SYSTEM
    ${LIBLIGHTDM_INCLUDE_DIRS}
    )

foreach(source_file ${QMLPLUGIN_SRC})
    list(APPEND RELATIVE_QMLPLUGIN_SRC ../${source_file})
endforeach()

add_library(FullLightDM-qml MODULE
    ${RELATIVE_QMLPLUGIN_SRC}
    )

target_link_libraries(FullLightDM-qml
    lomiri-private
    ${LIBLIGHTDM_LDFLAGS}
    ${LIBUSERMETRICSOUTPUT_LDFLAGS}
    ${Intl_LIBRARIES}
    Qt5::DBus Qt5::Gui Qt5::Qml
    )

add_lomiri_plugin(FullLightDM 0.1 LightDM/FullLightDM TARGETS FullLightDM-qml)

=== debian/changelog ===
lomiri (0.3.0-4build1) plucky; urgency=medium

  * Rebuild against new ppp 2.5.2-1+1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Feb 2025 15:26:27 +0100

lomiri (0.3.0-4) unstable; urgency=medium

  * debian/control:
    + Add D: (lomiri-common): ayatana-greeter-badges.
  * debian/patches:
    + Add 1010(a|b)_use-ayatana-greeter-badges.patch. Use badges from ayatana-
      greeter-badges project.
    + Add 1011_tests-copyright-check_copyright.sh-Ignore-new-lomiri.patch. Fix
      copyright test.
    + Add 0025_Drop-the-deprecated-PolicyKit-.pkla-file.patch. Cherry-picked
      from upstream. (Closes: #1078272, #1078318, #1093068, #1093069).
    + Add 1012_greeter-lomiri-indicators-target.patch. Launch Ayatana
      Indicators belonging to lomiri-indicators.target (not ayatana-
      indicators.target).
    + Add 1013_fix-convergence-on-high-resolution-tablets.patch. Fix
      convergence recognition on high resolution tablets.
    + Add 1014_plugins-Wizard-System.cpp-Restart-lomiri-indicators.patch.
    + Add 1015_greeter-textprompt-ESC-will-disable-OSK-again.patch. Provide
      a possibility to disable the OSK in the greeter again after having
      enabled it.
    + Add 1016_rotate-when-orientation-is-locked.patch. Early preview of Kugi
      Eusebio's 'otate button when orientation is locked' feature.
  * debian/lomiri-greeter.install:
    + Install policykit .rules file instead of the deprecated .pkla file.
  * debian/lomiri-common.install:
    + Install policykit's new .rule file instead of the deprecated .pkla file.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 31 Jan 2025 17:57:01 +0100

lomiri (0.3.0-3) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/control:
    + Add C (lomiri-greeter): unity-greeter. Avoid pulling in old Ubuntu
      Indicators + Unity Greeter on Ubuntu.
    + Add R: (lomiri): ciborium.
  * debian/patches:
    + Add 2012_no-app-suspension-on-Debian+Ubuntu-proper.patch. Don't suspend
      apps in Debian + Ubuntu proper.

  [ Guido Berhoerster ]
  * debian/:
    + Fix nocheck build profile (Closes: #1084810)

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 23 Oct 2024 09:53:54 +0200

lomiri (0.3.0-2) unstable; urgency=medium

  * debian/lomiri-common.install:
    + Don't use dh_install to copy-in Lomiri's launcher logo unconditionally.
  * debian/rules:
    + If building on non-Ubuntu, use the Lomiri logo in the launcher, if
      building on Ubuntu, use the Ubuntu logo (from the upstream code base).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 14 Aug 2024 11:16:55 +0200

lomiri (0.3.0-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * New upstream release.
  * debian/patches:
     + Drop patches that have been applied upstream.
       - 0016_support-vendor-accountsservice-interface.patch
       - 0021_set-z-index-of-spread-to-current-number-of-apps.patch
       - 0023_fix-build-on-32bit-arches-with-64bit-time-t.patch
       - 1007_fix-overwriting-INCLUDE_DIRECTORIES-variable.patch
       - 1009_fix-default-wallpaper-filename.patch
       - 1012_no-whitespace-checks-in-debian-folder.patch
       - 1013_fix-copyright-tests.patch
       - 1014_fix-test-AccountsService-interfaces-xml.patch
       - 1015_Meego-Ofono.patch
       - 1021-data-systemd-user-lomiri-MODE.service.in-Drop-indica.patch
       - 1022-data-systemd-user-CMakeLists.txt-lomiri-indicators.t.patch
       - 1023-data-systemd-user-lomiri-MODE.service.in-Use-lomiri-.patch
       - 1035-plugins-LightDM-fix-memory-corruption-after-resettin.patch
       - 1036-tst_DesktopStage-asynchronously-test-for-menu-positi.patch
       - 1037-tst_MenuBar-workaround-test-flakiness-by-giving-a-tr.patch
       - 1038-tst_MenuPopup-improve-reliability-of-the-test.patch
       - 2002_no-whitespace-checks-in-debian-subfolder.patch
    + Rebase all remaining patches.
    + Add 2010_use-desktop-qtmir.patch. Use Mir 2.x.
  * debian/rules:
    + Adjust dh_auto_test override, don't create test home if nocheck is set
      via DEB_BUILD_OPTIONS.
  * debian/control:
    + Mark various B-Ds as requirements for running unit tests.
    + Add B-D: lomiri-wallpapers (required for unit tests).
    + Bump Standards-Version to 4.7.0. No changes needed.
    + Bump versioned D on lomiri-system-settings to (>= 1.2.0-1~).
    + Bump versioned D on lomiri-schemas to (>= 0.1.5-1~).
  * debian/copyright:
    + Update copyright attributions.

  [ Guido Berhoerster ]
  * debian/patches:
    + Add 1009-Fix-compatibility-with-LightDM-1.32.patch

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 13 Aug 2024 12:23:17 +0200

lomiri (0.2.1-12) unstable; urgency=medium

  * debian/patches:
    + Add 102* patch series, introducing the lomiri-indicators.target for
      systemd.
    + Add 103* patch series, cherry-picked from upstream. Providing various
      test fixes and a memleak fix.
    + Tremendously reduce 2008_skip-failing-tests.patch, now only one sub-
      directory skipped during unit tests.
  * debian/lomiri.install:
     + Install lomiri-indicators.target into lomiri bin:pkg.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 22 May 2024 12:13:32 +0200

=== debian/control ===
Source: lomiri
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends:
 cmake,
 cmake-extras,
 dbus-test-runner <!nocheck>,
 debhelper-compat (= 13),
 dh-apparmor,
 doxyqml,
 graphviz,
 lomiri-schemas (>= 0.1.5-1~),
 lomiri-wallpapers <!nocheck>,
 libdeviceinfo-dev,
 libevdev-dev,
 libgeonames-dev (>= 0.2),
 libgl-dev[!arm64 !armhf],
 libgl1-mesa-dri,
 libgles2-mesa-dev[arm64 armhf],
 libglib2.0-dev,
 libgnome-desktop-3-dev,
 libgsettings-qt-dev,
 liblightdm-qt5-3-dev,
 liblomiri-connectivity-qt1-dev,
 libpam0g-dev,
 libpulse-dev,
 libqmenumodel-dev (>= 0.2.12),
 libqtmirserver-dev (>= 0.8.0~git20230223.bd21224-3~),
 libmiroil-dev,
 libmiral-dev,
 libqt5sql5-sqlite,
 libqt5svg5-dev,
 libqt5xmlpatterns5-dev,
 libqtdbusmock1-dev (>= 0.7) <!nocheck>,
 libqtdbustest1-dev <!nocheck>,
 libsystemd-dev [linux-any],
 liblomirisystemsettings-dev,
 liblomiri-app-launch-dev (>= 0.1.5),
 liblomiri-download-manager-common-dev,
 liblomirigestures-dev (>= 1.3.2030),
 liblomirigestures5-private-dev (>= 1.3.2030),
 libudev-dev,
 libldm-common-dev,
 liblomiri-api-dev (>= 0.2.0),
 libusermetricsoutput-dev,
 libx11-dev[!arm64 !armhf],
 libxcb1-dev[!arm64 !armhf],
 libxi-dev[!arm64 !armhf],
 libxcb-dri2-0-dev[!arm64 !armhf],
 licensecheck,
 mir-platform-graphics-x,
 mirtest-dev <!nocheck>,
 pkgconf,
 python3-all:any,
 python3-setuptools,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmultimedia (>= 5.6),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-layouts,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtquick2,
 qml-module-qtsysteminfo,
 qml-module-qttest <!nocheck>,
 qml-module-lomiri-components (>= 1.3.5000),
 qml-module-lomiri-layouts,
 qml-module-lomiri-settings-components,
 qml-module-lomiri-settings-menus,
 qml-module-lomiri-test <!nocheck>,
 qml-module-qtmir,
 qtbase5-dev (>= 5.6),
 qtbase5-dev-tools,
 qtbase5-private-dev (>= 5.6),
 qtdbustest-runner <!nocheck>,
 qtdeclarative5-dev (>= 5.6),
 qtdeclarative5-dev-tools,
 qtdeclarative5-private-dev (>= 5.6),
 qml-module-lomiri-content,
 systemd-dev [linux-any],
# fonts-ubuntu,
 xvfb <!nocheck>,
 xauth <!nocheck>,
 xwayland,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
 libboost-filesystem-dev,
 libboost-system-dev,
 rdfind,
 symlinks,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri

Package: lomiri-greeter
Architecture: all
Depends:
 lomiri (>= ${source:Version}), lomiri (<< ${source:Version}.1~),
 lightdm,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 arctica-greeter,
 arctica-greeter-guest-session,
 arctica-greeter-remote-logon,
 unity-greeter,
Provides:
 lightdm-greeter,
Description: LightDM Greeter for the Lomiri Operating Environment
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri Greeter.

Package: lomiri
Architecture: any
Provides:
 indicator-renderer,
 notification-daemon
Depends:
 ayatana-indicator-bluetooth,
 ayatana-indicator-datetime,
 ayatana-indicator-display,
 ayatana-indicator-keyboard,
 ayatana-indicator-messages,
 ayatana-indicator-power,
 ayatana-indicator-session,
 ayatana-indicator-sound,
 lomiri-app-launch (>= 0.1.5),
 dmz-cursor-theme,
 gsettings-desktop-schemas,
 libcap2-bin,
 libglib2.0-bin,
 qml-module-biometryd,
 qml-module-lomiri-components,
 qml-module-lomiri-layouts,
 qml-module-lomiri-telephony,
 qml-module-lomiri-settings-menus,
 qml-module-qmenumodel1,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmir (>= 0.4.8),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtsysteminfo,
 qml-module-hfd,
 qtmir,
 lomiri-indicator-network,
 lomiri-system-settings (>= 1.2.0-1~),
 lomiri-url-dispatcher,
 lomiri-launcher-impl-13,
 lomiri-common (>= ${source:Version}), lomiri-common (<< ${source:Version}.1~),
 liblomiri-private0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ciborium,
 mir-platform-graphics-gbm-kms | mir-platform-graphics-eglstream-kms | mir-platform-graphics-wayland | mir-platform-graphics-x,
 lomiri-desktop-session | lomiri-touch-session,
 lomiri-greeter,
 lomiri-greeter-session-broadcast,
 lomiri-indicator-transfer,
 lomiri-polkit-agent,
 maliit-keyboard,
Breaks:
 indicator-network (<< 0.5.1+14.10.20141014),
 lomiri-keyboard (<< 0.100),
 lomiri-touch-session (<< 0.107),
 lomiri-scope-tool,
Replaces:
 lomiri-touch-session (<< 0.82~),
 lomiri-scope-tool,
Conflicts:
 lomiri-system-settings-wizard,
Description: Shell of the Lomiri Operating Environment
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri shell.

Package: lomiri-common
Architecture: all
Depends:
 ayatana-greeter-badges,
 qml-module-qtquick-layouts,
 qml-module-lomiri-components (>= 1.3.2030) | qml-module-lomiri-components-gles (>= 1.3.2030),
 qml-module-lomiri-settings-components,
 qml-module-lomiri-thumbnailer,
 qtdeclarative5-lomiri-notifications-plugin (>= 0.1.2) | lomiri-notifications-impl,
 qttranslations5-l10n,
 lomiri-application-impl-27,
 lomiri-notifications-impl-3,
 lomiri-schemas (>= 0.1.5-1~),
 lomiri-tests <!nocheck> | lomiri-application-impl,
 ${misc:Depends},
Description: Shell of the Lomiri Operating Environment (common files)
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the QML, graphics and locale files for lomiri.

Package: lomiri-tests
Architecture: any
Multi-Arch: foreign
Depends:
 dbus-test-runner,
 parallel,
 qtdbustest-runner,
 qtdeclarative5-dev-tools,
 lomiri (= ${binary:Version}),
 xauth,
 xvfb,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-application-impl,
 lomiri-application-impl-27,
 lomiri-fake-env,
Replaces:
 lomiri-autopilot (<< 8.02+15.04.20150422-0lomiri1),
 lomiri-fake-env,
Conflicts:
 lomiri-fake-env,
Build-Profiles: <!nocheck>
Description: Scripts and mocks for running Lomiri Shell tests
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides fake implementations of some QML modules used by
 the Lomiri Shell (e.g. Lomiri.Application) so that you can run it in a
 sandboxed environment; it also provides scripts to run its test suite.

Package: liblomiri-private0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 lomiri-schemas (>= 0.1.5-1~),
 qml-module-gsettings1.0,
 qml-module-qtmultimedia,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-launcher-impl,
 lomiri-launcher-impl-13,
Breaks:
 lomiri-private,
Replaces:
 lomiri-private,
Description: Lomiri Operating Environment's Shell (private libs)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the private libraries for QML and other components
 only used by the Lomiri Shell.

Package: lomiri-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Lomiri Operating Environment's Shell (documentation files)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides documentation of the Lomiri Shell.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export NO_PNG_PKG_MANGLE=1
export QT_SELECT=qt5

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Skip tests on the archs they are known to be flaky  with current configuration
testskip_architectures := arm64 powerpc ppc64el s390x

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
export CONFIGURE_FLAGS := -DENABLE_UBUNTU_ACCOUNTSSERVICE=ON
endif

ifneq ($(filter nocheck,$(DEB_BUILD_PROFILES)),)
    CONFIGURE_FLAGS += -DNO_TESTS=ON
endif

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	# Debian defines CMAKE_INSTALL_LOCALSTATEDIR as /usr/var, which is wrong.
	# So until Debian bug 719148 is fixed, do it ourselves.
	dh_auto_configure -- -DCMAKE_INSTALL_LOCALSTATEDIR="/var" \
	                     -DDISPLAYED_DISTRO_NAME="Debian Lomiri" \
	                     -DWITH_MIR2=ON \
	                     $(CONFIGURE_FLAGS)

override_dh_auto_build:
	# doc is not a default target
	dh_auto_build -- -O all doc

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p debian/home
	export HOME=debian/home
	# Run the entire test battery
	# Parallel tests have a risk of starting xvfb on the same DISPLAY multiple times,
	# causing the whole battery to fail.
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	-dh_auto_test --no-parallel -- -O -k xvfballtests
else
	# FIXME: Temporarily disable unit tests on all other architectures, as well. They
	# seem flaky when built+run on systems more recent than Ubuntu 20.04...
	dh_auto_test --no-parallel -- -O -k xvfballtests
endif
endif

override_dh_fixperms:
	dh_fixperms
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Session/libSessionBackendTestPreload.so || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/abs-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.svg || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/no-name.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.svg || true

override_dh_install:
	rm debian/tmp/usr/bin/indicators-client
	rm debian/tmp/usr/share/applications/indicators-client.desktop
	rm debian/tmp/usr/share/lomiri/unlock-device
	rm debian/tmp/usr/lib/systemd/user/*.service
	cd debian/tmp/usr/share/doc/lomiri/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/lomiri/html/ && symlinks -rc .
ifneq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	cp debian/home.svg debian/tmp/usr/share/lomiri/Launcher/graphics/
endif
	dh_install

override_dh_installdocs:
	dh_installdocs
	# Remove results.txt for reproducible builds
	rm -vf debian/lomiri-doc/usr/share/doc/lomiri/html/results.txt

# use private lib directories
override_dh_makeshlibs:
	dh_makeshlibs -Nlomiri-tests

override_dh_shlibdeps:
	# Some mock libraries link against liblightdm-qt5-3.so which we want to
	# avoid, since we only really link against our mock one, not the system one.
	dh_shlibdeps -XlibMockAccountsService-qml.so -Lliblomiri-private0

override_dh_clean:
	rm -Rfv debian/home
	dh_clean

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri 0.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required (VERSION 3.5.0)
+cmake_minimum_required (VERSION 3.7.0)
 
 # Default install location. Must be set here, before setting the project.
 if (NOT DEFINED CMAKE_INSTALL_PREFIX)
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(lomiri VERSION 0.3.0 LANGUAGES C CXX)
+project(lomiri VERSION 0.4.0 LANGUAGES C CXX)
 
 option (ENABLE_UBUNTU_ACCOUNTSSERVICE "Build with Ubuntu's fork of accountsservice" OFF)
 
@@ -101,6 +101,7 @@
 pkg_check_modules(LOMIRIGESTURES REQUIRED LomiriGestures)
 pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
 pkg_check_modules(LOMIRISCHEMA REQUIRED lomiri-schemas>=0.1.4)
+pkg_check_modules(LIBLIGHTDM REQUIRED liblightdm-qt5-3)
 
 option(WITH_MIR2 "Build against Mir 2" OFF)
 
@@ -133,9 +134,9 @@
 set(SHELL_PRIVATE_FULL_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR}/lomiri)
 set(SHELL_PRIVATE_FULL_LIBEXECDIR ${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri)
 
-execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugin_private_module_dir LomiriSystemSettings OUTPUT_VARIABLE USS_PRIVATE_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
-if(USS_PRIVATE_PLUGINDIR STREQUAL "")
-    message(FATAL_ERROR "Could not determine USS private plugin installation dir.")
+execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugin_private_module_dir LomiriSystemSettings OUTPUT_VARIABLE LOMIRI_SYSTEM_SETTINGS_PRIVATE_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+if(LOMIRI_SYSTEM_SETTINGS_PRIVATE_PLUGINDIR STREQUAL "")
+    message(FATAL_ERROR "Could not determine LomiriSystemSettings private plugin installation dir.")
 endif()
 
 execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix lomiri-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)

## lomiri 0.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(lomiri VERSION 0.4.0 LANGUAGES C CXX)
+project(lomiri VERSION 0.4.1 LANGUAGES C CXX)
 
 option (ENABLE_UBUNTU_ACCOUNTSSERVICE "Build with Ubuntu's fork of accountsservice" OFF)

=== plugins/Wizard/CMakeLists.txt ===
pkg_search_module(GD3 REQUIRED gnome-desktop-3.0)

include_directories(SYSTEM ${GD3_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS} ${GEONAMES_INCLUDE_DIRS})

add_library(Wizard-qml MODULE
    plugin.cpp
    PageList.cpp
    System.cpp
    LocalePlugin.cpp
    timezonemodel.cpp
    Status.cpp
    keyboardLayoutsModel.cpp
    Changelog.cpp
)

target_link_libraries(Wizard-qml
    Qt5::DBus Qt5::Qml
    ${GD3_LDFLAGS} ${GLIB_LDFLAGS} ${GEONAMES_LDFLAGS}
)

if (NOT "${DISPLAYED_DISTRO_NAME}" STREQUAL "")
    target_compile_definitions(Wizard-qml PRIVATE
        -DLOMIRI_DISPLAYED_DISTRO_NAME="${DISPLAYED_DISTRO_NAME}")
endif ()

add_lomiri_plugin(Wizard 0.1 Wizard TARGETS Wizard-qml)

install(FILES 50-com.lomiri.wizard.rules DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/rules.d")

=== tests/plugins/GlobalShortcut/CMakeLists.txt ===
include_directories(
    ${CMAKE_SOURCE_DIR}/plugins/GlobalShortcut
    ${CMAKE_CURRENT_BINARY_DIR}
    )

add_definitions(-DTEST_DIR="plugins/GlobalShortcut")

add_executable(GlobalShortcutTestExec GlobalShortcutTest.cpp ${CMAKE_SOURCE_DIR}/plugins/GlobalShortcut/globalshortcut.cpp)
target_link_libraries(GlobalShortcutTestExec Qt5::Test Qt5::Quick ${Qt5Quick_LIBRARIES} GlobalShortcut-qml)
install(TARGETS GlobalShortcutTestExec
    DESTINATION "${SHELL_PRIVATE_FULL_LIBEXECDIR}/tests/plugins/GlobalShortcut"
)
install(FILES shortcut.qml
    DESTINATION "${SHELL_APP_FULL_DIR}/tests/plugins/GlobalShortcut"
)
add_lomiri_uitest(GlobalShortcut GlobalShortcutTestExec
        DEPENDS GlobalShortcut-qml
        ENVIRONMENT LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/plugins/GlobalShortcut
)

=== tests/mocks/Lomiri/Telephony/CMakeLists.txt ===
set(FakeLomiriTelephonyQml_SOURCES
    plugin.cpp
    ContactWatcherData.cpp
    MockCallEntry.cpp
    MockCallManager.cpp
    MockContactWatcher.cpp
    MockTelepathyHelper.cpp
)

add_library(FakeLomiriTelephonyQml MODULE ${FakeLomiriTelephonyQml_SOURCES})

target_link_libraries(FakeLomiriTelephonyQml Qt5::Core Qt5::Quick)

add_lomiri_mock(Lomiri.Telephony 0.1 Lomiri/Telephony TARGETS FakeLomiriTelephonyQml)

=== debian/changelog ===
lomiri (0.4.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patches 0001, 0002, 0004, 0005, 0007, 0014, 0025 and 1019. All
      applied upstream.
  * debian/copyright:
    + Update to new FSF mailing address.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 17 Apr 2025 22:07:56 +0200

lomiri (0.4.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + (Temporarily) drop patches 0006, 0008, 0009, 0010, 0011. They don't
      apply anymore and rebasing is not trivial. (Upstream author has been
      notified on this).
    + Trivial rebase of patches 0002, 0004, 0005, 0024, 0025, 1001, 1013,
      1016, 2006, 2010, 2012.
    + Drop patches 0013, 0015, 0025, 1005, 1009, 1011, 1014. All applied
      upstream.
    + Temporarily add 1017_dont-load-indicators-for-unregistered-services.patch
      (not accepted upstream, but solving the problem).
    + Add 1018_plugins-Cursor-fix-jumpy-windows-during-edge-snap.patch. Fix
      jumpy windows on edge snap.
    + Add 1019_qml-Color-Drop-labels-in-Workspace-preview-in-white.patch. qml:
      Color Drop labels in Workspace preview in white. Follow the coloring of
      the individual Images representing "Drop here" and "Drop and go" for both
      dark and light mode.
    + Add 0025_fix-lomiri-startup-failures.patch. Fix Lomiri session startup
      failures.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
    + In R:, replace maliit-keyboard by lomiri-keyboard.
    + Also recommend lomiri-keyboard for lomiri-greeter.
    + Switch from ayatana-indicator-datetime to lomiri-indicator-datetime.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 03 Apr 2025 14:58:34 +0200

lomiri (0.3.0-5) unstable; urgency=medium

  * Rebuild against Mir 2.20.
  * debian/patches:
    + Add 2013_CXX-standard-20.patch. Bump to CXX standard v20.
  * debian/control:
    + Require Mir 2.20 everywhere.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 15 Mar 2025 08:34:41 +0100

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
  libpam0g-dev,
  libpulse-dev,
  libqmenumodel-dev (>= 0.2.12),
- libqtmirserver-dev (>= 0.8.0~git20230223.bd21224-3~),
+ libqtmirserver-dev (>= 0.8.0~git20250305.794fa12-2~),
  libmiroil-dev,
  libmiral-dev,
  libqt5sql5-sqlite,
@@ -71,7 +71,7 @@
  qml-module-lomiri-settings-components,
  qml-module-lomiri-settings-menus,
  qml-module-lomiri-test <!nocheck>,
- qml-module-qtmir,
+ qml-module-qtmir (>= 0.8.0~git20250305.794fa12-2~),
  qtbase5-dev (>= 5.6),
  qtbase5-dev-tools,
  qtbase5-private-dev (>= 5.6),
@@ -90,7 +90,7 @@
  libboost-system-dev,
  rdfind,
  symlinks,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri.git
@@ -103,6 +103,8 @@
  lightdm,
  ${misc:Depends},
  ${shlibs:Depends},
+Recommends:
+ lomiri-keyboard,
 Conflicts:
  arctica-greeter,
  arctica-greeter-guest-session,
@@ -125,7 +127,6 @@
  notification-daemon
 Depends:
  ayatana-indicator-bluetooth,
- ayatana-indicator-datetime,
  ayatana-indicator-display,
  ayatana-indicator-keyboard,
  ayatana-indicator-messages,
@@ -145,12 +146,13 @@
  qml-module-qmenumodel1,
  qml-module-qt-labs-folderlistmodel,
  qml-module-qt-labs-settings,
- qml-module-qtmir (>= 0.4.8),
+ qml-module-qtmir (>= 0.8.0~git20250305.794fa12-2~),
  qml-module-qtqml-statemachine,
  qml-module-qtquick-xmllistmodel,
  qml-module-qtsysteminfo,
  qml-module-hfd,
- qtmir,
+ qtmir (>= 0.8.0~git20250305.794fa12-2~),
+ lomiri-indicator-datetime,
  lomiri-indicator-network,
  lomiri-system-settings (>= 1.2.0-1~),
  lomiri-url-dispatcher,
@@ -167,7 +169,7 @@
  lomiri-greeter-session-broadcast,
  lomiri-indicator-transfer,
  lomiri-polkit-agent,
- maliit-keyboard,
+ lomiri-keyboard,
 Breaks:
  indicator-network (<< 0.5.1+14.10.20141014),
  lomiri-keyboard (<< 0.100),
